
-- Test callbacks
--
-- Copyright (c) 2001-2004 Nick Trout
-- This file is part of Doris. (http://doris.sf.net/)
-- Doris is free software. See terms of GNU license in docs.
-- $Id: callbacks.lua,v 1.4 2004/02/25 02:42:51 trout Exp $

parts = {}
vx,vy = 0,0

function mouseEvent(butt,state,x,y)
  if butt==0 and state==1 then
    parts[x] = { x=x, y=y, age=400 }
    return 1 -- force redraw
  end
end

function dragEvent(x,y)
  parts[x] = { x=x, y=y, age=10 }
end

function moveEvent(x,y)
  vx, vy = (x-.5)*.01, (y-.5)*.01
  return 1 -- force redraw
end

function keyEvent(k)
  print("Key: " .. k)
end

-- The callback function which renders our scene.
--
function renderScene()
  glClear(GL_DEPTH_BUFFER_BIT + GL_COLOR_BUFFER_BIT)

  -- Tell the camera/eye what to look at
  gluLookAt(0,0,1, 0,0,0, 0,1,0)
  glMatrixMode(GL_MODELVIEW)

  glPushMatrix()
  glLoadIdentity()
    for k,v in parts do
      glPushMatrix()
        glTranslate(v.x-.5,v.y-.5,0)
        glutWireCube(.05)
      glPopMatrix()
      v.age = v.age-1
      v.x,v.y = v.x+vx, v.y+vy
      if v.age<=0 then parts[k]=nil end
    end
  glPopMatrix()
end

-- Create our window and specify a name and window rendering function
--
wmain = Window:create{
  title = "Doris: Simple example",
  render = renderScene, -- specify the redraw function for this window
  mouse = mouseEvent,
  drag = dragEvent,
  move = moveEvent,
  key = keyEvent,
  idle = function() return 1 end -- keep forcing redraw
}


