
-- Logo for Lua. Interactive user entry.
--
-- Copyright (c) 2001-2004 Nick Trout
-- This file is part of Doris. (http://doris.sf.net/)
-- Doris is free software. See terms of GNU license in docs.
-- $Id: logo.lua,v 1.8 2004/02/25 02:42:51 trout Exp $

scene = { rotmat=Matrix:new(), scalemat=Matrix:new() }
pointer = { rotmat=Matrix:new(), scalemat=Matrix:new() }

function makePointer()
end

function home()
  pos,ori = {0,0,0},{0,0,0}
end

function reset()
  CallList:clear()
  home()
  mode = "line"
end

function info()
  print("Position:",pos[1],pos[2],pos[3])
  print("Orientation:",pos[1],pos[2],pos[3])
end

function compileScene()
  CallList:Clear()

  CallList:Begin("sphere")
  Quadric:Sphere(sphere)
  CallList:End()

  CallList:Begin("teapot")
  Quadric:Teapot(teapot)
  CallList:End()
end

function renderScene()
  gluLookAt(0,0,10, 0,0,0, 0,1,0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glPushMatrix()
    -- scene
    glLoadMatrix(scene.scalemat:getArray())
    glMultMatrix(scene.rotmat:getArray())
    glutWireCube(5)

    -- sphere
    --glPushMatrix()
    --  glMultMatrix(sphere.rotmat:getArray())
    --  CallList:draw("sphere")
    --glPopMatrix()

    -- teapot
    --glPushMatrix()
    --  glMultMatrix(teapot.rotmat:getArray())
    --  CallList:draw("teapot")
    --glPopMatrix()

  glPopMatrix()
end

reset() -- reset before we start
info()

wmain = Window:Create{
  title = "Doris: Logo",
  render = renderScene
}

sw=SubWindow{ parent=wmain, side="bottom" }

  ro=Rotator{ parent=sw, value=scene.rotmat, text="Scene", line="v" }

  ro=Edit{  parent=sw, text="Enter commands here:", type=text, width=500,
            update = function(x)
              print ("User command: ",x)
              local r=dostring(x)
              print (r)
            end
          }

