
-- Simple example
--
-- Copyright (c) 2001-2004 Nick Trout
-- This file is part of Doris. (http://doris.sf.net/)
-- Doris is free software. See terms of GNU license in docs.
-- $Id: simple.lua,v 1.14 2004/02/25 04:54:04 trout Exp $

-- create a matrix to rotate the scene
rotatemat = Matrix:new()

-- The callback function which renders our scene.
--
function renderScene()
  -- Clear the screen and depth buffer
  glClear(GL_DEPTH_BUFFER_BIT + GL_COLOR_BUFFER_BIT)

  -- Tell the camera/eye what to look at
  gluLookAt(0,0,10, 0,0,0, 0,1,0)
  glMatrixMode(GL_MODELVIEW)

  -- Draw the scene.
  glPushMatrix()
    glLoadMatrix(rotatemat)
    glutWireCube(5)
    Quadric:teapot{}
  glPopMatrix()
end

-- Create our window and specify a name and window rendering function
--
wmain = Window:create {
    title = "Doris: Simple example",
    render = renderScene -- specify the redraw function for this window
}

-- Put a sub window at the bottom of the screen
--
subwin = SubWindow { parent=wmain, side="bottom" }

-- Add an object rotator to the bottom of the screen that
-- manipulates the matrix we created.
--
rot = Rotator {
    parent = subwin,       -- parent of this widget
    text = "Rotate scene", -- text label for this widget
    value = rotatemat,     -- matrix that rotator manipulates
    line = "|",            -- vertical spacing line drawn
    spin = 0.99     -- allow the rotator to spin with little damping when released
}


